Vue.config.productionTip = false // 关闭vue生产环境提示
/**
 * @description: 固定定位模拟黏性定位；（前提：jq库支持；）
 * @params: {Selector} stickySel 触发黏性定位的选择器；
 * @params: {Selector} siblingSel 触发黏性定位的选择器 - 同级容器
 * @params: {Selector} size 触发黏性定位的选择器高；（用于计算何时移出固定定位）
 * */
function changeFilterHead(stickySel, siblingSel, size0, size1, SusFixNavHei) {
    var $stickyFilter = $(stickySel) // 触发黏性定位的选择器
    var windowScroll = $(window).scrollTop() + size0 // 网页被卷曲的距离
    var stickyFilterWidth = $stickyFilter.offset().top // 需要定位的容器到顶部距离
    var nextSize = $(siblingSel).offset().top // 同级容器到顶部距离
    // console.log('定位尺寸', windowScroll, stickyFilterWidth, nextSize)
    if (windowScroll > stickyFilterWidth) {
        $stickyFilter.css({
            'position': 'fixed',
            'top': size0 + 'px', // 固定定位位置
            'width': '100%',
            'left': 0,
            'z-index': '98',
        })
        $(siblingSel).css({
            'padding-top': size1 + SusFixNavHei + 'px', // 原始上内边距 + 固定塌陷造成的高
        })
        stickyFilterWidth -= SusFixNavHei // ！触发定位后，要将自身高度减去用于比较
        return
    }
    if (windowScroll < nextSize) {
        $stickyFilter.removeAttr('style')
        $(siblingSel).css({ // 给因固定定位造成的塌陷，添加内距
            'padding-top': SusFixNavHei + 'px'
        })
    }
}
var vum = new Vue({
    el: '#app',
    data: function () {
        return {
            loading: false, // 是否正在 loading
            isEmpty: 'none', // 是否为空
            baseUrl: testbaserequiredurl, // 当前服务路径
            currentPage: 1, // 当前选中页码
            allIndClassArr: [
                {indName: '专利技术', isSel: 0, id: 1, count: 0},
                {indName: '商标品牌', isSel: 0, id: 2, count: 0},
                {indName: '版权软著', isSel: 0, id: 3, count: 0},
                {indName: '科技人才', isSel: 0, id: 4, count: 0},
            ], // 需求分类
            // 请求参数对象
            keyword: '',
            typeIdList: [], // （请求用）需求分类
            publishTimeSort: 0, // 发布时间排序 0倒序 1升序
            hotSort: '', // 热度排序 0倒序 1升序
            renderListData: [], // 列表渲染数组
            // 分页相关
            listDataCount: 0, // 数据总量
            page: 1,
            limit: 0,

            //需求弹框
            dialogFormVisible: false,
            form: {
                needUser: '',
                needType: '1',
                needdes: '',
                currUserType: ""
            },
            formLabelWidth: '75px',


        }
    },
    computed: {
        // 总页数
        countPage: function () {
            return Math.ceil(this.listDataCount / this.limit)
        }
    },
    created: function () {
        var _this = this
        // 初始化页面数
        _this.limit = $('#curPageSize').val()
        // 化需求分类的数量统计
        $.ajax({
            url: testbaserequiredurl + '/need/countNeed.html',
            data: {},
            type: 'POST',
            success: function (res) {
                var res = JSON.parse(res)
                if (res.code == 0) {
                    var obj = res.data;
                    _this.allIndClassArr.forEach(function (item, index) {
                    	if (obj[item.id] != null) {
                    		item.count = obj[item.id].needCount
                    	}
                    })
                }
            },
            error: function (err) {

            },
            complete: function () {

            }
        })
        // 获取列表页面的显示条数
        _this.getListData()
    },
    mounted: function () {
        var _this = this
        if(getUrlParam('showmodal')){
          $(".com__show--head--pbslayout>li").click()
          changeURLStaticLoginModal('showmodal')
        }
        // 修改每页尺寸
        $('.pageSizeSelect').change(function () {
            _this.limit = $(this).val()
            $(".pageSizeSelect").val(_this.limit) // 设置默认的每页尺寸
            _this.page = 1
            $.ajax({
                url: _this.baseUrl + '/user/setPageSize.html?pageSize=' + _this.limit,
                type: 'get',
                async: false,
                success: function () {
                }
            })
            _this.getListData()
        })
        // 滚动监听
        $(window).scroll(function () {
            changeFilterHead('.operation__bar--pbslayout', '.fixed__sib', 70, 60, 0)
            // 溢出隐藏
            var t = document.documentElement.scrollTop || document.body.scrollTop || window.pageYOffset;
            if (t > $(".new_footer")[0].offsetTop - 90) {
                $(".operation__bar--pbslayout").hide()
            } else {
                $(".operation__bar--pbslayout").show()
            }
        })
    },
    methods: {
        //提示框
        messageTips: function (message,type) {
            var _this = this;
            _this.$message.closeAll();
            _this.$message({
                message: message,
                type: !type?'warning':type,
                offset: 90
            })
        },
        //分页
        getFirstPage: function () { // 获取第1页数据
            var _this = this;
            if (_this.page == 1) {
                return _this.messageTips('当前已在首页！')
            }
            _this.page = 1
            _this.getListData()
        },
        getNextPage: function () { // 获取下一页
            var _this = this;
            if (_this.page >= _this.countPage) return _this.messageTips('当前已在尾页！')
            _this.page++
            _this.getListData()
        },
        getPrevPage: function () { // 获取上一页
            var _this = this;
            if (_this.page == 1) return _this.messageTips('当前已在首页！')
            _this.page--
            _this.getListData() // 重新获取数据
        },
        getLastPage: function () {
            var _this = this;
            if (_this.page >= _this.countPage) {
                return _this.messageTips('当前已在尾页！')
            }
            _this.page = _this.countPage // 这里是需要计算的
            _this.getListData() // 重新获取数据
        },
        //点击搜索
        getSearchResult: function () {
            this.resetSearchCriteria()
            this.getListData()
        },
        // 清空搜索关键词
        clearSearchKw: function () {
            this.keyword = ''
        },
        // 重置搜索条件
        resetSearchCriteria: function () {
            var _this = this
            _this.resetTypeIdList(_this) // 重置筛选项-需求分类
            _this.resetGrayFilterItems() // 重置排序
            _this.page = 1 // 页码
        },
        resetTypeIdList: function (_this) { // 重置需求分类
            _this.typeIdList = [] //（请求用）需求分类
            _this.allIndClassArr.forEach(function (item) {
                item.isSel = 0
            })
        },
        resetGrayFilterItems: function () { // 重置 排序
            this.publishTimeSort = 0
            this.hotSort = ''
        },
        // 点击需求分类
        setTypeIdList: function (id) {
            var _this = this
            _this.page = 1
            if (id === 0) { // 点击“不限”
                _this.resetTypeIdList(_this) // 重置筛选项-需求分类
            } else { //点击子项
                _this.allIndClassArr.forEach(function (item) {
                    if (item.id === id) {
                        if (item.isSel === 0) {
                            item.isSel = 1
                            _this.typeIdList.push(item.id)
                        } else {
                            item.isSel = 0
                            _this.typeIdList.splice(_this.typeIdList.indexOf(item.id), 1)
                        }
                    }
                })
            }
            _this.getListData() // 重新获取数据
        },
        //点击操作栏排序
        setFilterItems: function (type) { // 设置过滤项
            this.page = 1
            // if (type === 0) { //综合排序
            //     // 处理请求数据
            //     this.publishTimeSort = ''
            //     this.hotSort = ''
            // } else
            if (type === 1) { // 发布时间
                // 处理请求数据
                this.hotSort = ''
                if (this.publishTimeSort == 1 || this.publishTimeSort === '') {
                    this.publishTimeSort = 0
                } else {
                    this.publishTimeSort = 1
                }
            } else { // 热度排序
                this.publishTimeSort = ''
                // 处理请求数据
                if (this.hotSort == 1 || this.hotSort === '') {
                    this.hotSort = 0
                } else {
                    this.hotSort = 1
                }
            }
            this.getListData() // 重新获取数据
        },
        //列表接口
        getListData: function () {
            var _this = this
            _this.loading = true // 开始加载 loading
            _this.isEmpty = 'none' // 隐藏置空
            _this.renderListData = [] // 清空数据
            var reqObj = {
                page: _this.page,
                limit: _this.limit,
                keyword: _this.keyword,
                typeIdList: _this.typeIdList.join(','),
                publishTimeSort: _this.publishTimeSort,
                hotSort: _this.hotSort
            }
            $.ajax({
                url: testbaserequiredurl + '/need/listData.html',
                data: reqObj,
                type: 'POST',
                success: function (res) {
                    var res = JSON.parse(res)
                    if (res.code == 0) {
                        _this.renderListData = res.data.list // 列表数据赋值
                        _this.listDataCount = res.data.count // 数据总量
                        $('html , body').animate({scrollTop: 0}, 'slow')// 回到顶部
                        if (_this.renderListData.length == 0) {
                            _this.isEmpty = 'flex'
                        }
                        $(".pageSizeSelect").val(_this.limit) // 更新每页尺寸
                    } else {
                        _this.isEmpty = 'flex'
                        _this.messageTips('请求出错, 请稍后再访问','error')
                    }
                },
                error: function (err) {

                },
                complete: function () {
                    _this.loading = false // 停止加载 loading
                }
            })
        },
        //跳转
        linkHandle:function (e){
            window.open($(e.target).attr("data-href"))
        },
        //移入移除统计热度
        // 移入
        mouseOver:function(id,index) {
            var _this = this
            //
            $.ajax({
                url: testbaserequiredurl + '/need/updateHot.html',
                data: {needId:id},
                type: 'POST',
                success: function (res) {
                    var res = JSON.parse(res)
                    if (res.code == 0) {
                        var data = res.data;
                        _this.renderListData[index].hot = data
                    }
                },
                error: function (err) {

                },
                complete: function () {

                }
            })
        },
        //发布需求
        addNeed: function (e) {
            var _this = this;
            var ele = $(e.target);
            if (!ele.attr("disabled")) {
                ele.attr("disabled", true)
                $.ajax({
                    url: testbaserequiredurl + '/need/loadDraftInfo.html',
                    data: {},
                    type: 'POST',
                    success: function (res) {
                        var res = JSON.parse(res)
                        ele.attr("disabled", false)
                        if (res.code == 0) {
                            var data = res.data;
                            _this.form.currUserType = data.userType //0普通用户，1会员，2客服
                            if (_this.form.currUserType == 0) {
                                _this.messageTips('请联系官方客服代发','success')
                            } else {
                                _this.dialogFormVisible = true
                                _this.form.vips = data.vips;
                                _this.form.recommendUsers = data.recommendUsers;
                                _this.form.draftNeed = data.draftNeed;
                                if (!data.draftNeed) {
                                    _this.form.needUser = ''
                                    _this.form.needType = '1'
                                    _this.form.needdes = ''
                                } else {
                                    _this.form.needUser = data.draftNeed.needUser
                                    _this.form.needType = data.draftNeed.needType
                                    _this.form.needdes = data.draftNeed.content
                                }
                            }
                        } else {
                            loginFormModal()
                        }
                    },
                    error: function (err) {

                    },
                    complete: function () {

                    }
                })
            }

        },
        chooseUserHandle: function (id) {
            var _this = this;
            _this.form.needUser = id
        },
        formSubmitHandle: function (type) {
            var _this = this;

            if (_this.form.currUserType == 2 && _this.form.needUser == "") {
                _this.messageTips('请选择需求用户','error')
                return
            }
            if (_this.form.needdes.trim() == "") {
                _this.messageTips('请输入需求说明','error')
                return
            }
            var obj = {
                needId: !_this.form.draftNeed ? '' : _this.form.draftNeed.needId,
                needUser: !_this.form.needUser ? '' : _this.form.needUser,
                needType: _this.form.needType,
                content: _this.form.needdes,
                checkStatus: type //存草稿传0，提交传1
            }
           $(".disabledref").attr("disabled",true)
            $.ajax({
                url: testbaserequiredurl + '/need/saveNeed.html',
                data: obj,
                type: 'POST',
                success: function (res) {
                    var res = JSON.parse(res)
                    $(".disabledref").attr("disabled",false)
                    _this.dialogFormVisible = false
                    if (type == 0) {
                        //    保存草稿
                        _this.messageTips('保存成功','success')
                    } else if (type == 1) {
                        //    提交需求
                    	if (_this.form.needUser == '' && type == 1) {
                    		var cname = res.data==null||res.data==''?'':' '+res.data+' ';
                    		_this.messageTips('提交成功，需要对应业务员'+cname+'进行审核通过即可在线显示','success')
                    	} else {
                    		_this.messageTips('提交成功','success')
                    	}
                        if (_this.form.needUser != '' && type == 1) {
                            // 刷新页面
                            _this.getListData();
                        }
                    }


                },
                error: function (err) {

                },
                complete: function () {

                }
            })

        },
        linkQq:function (e) {
            var ele = $(e.target);
            var qq = ele.html();
            if (qq != "") {
            	if (qq.length>10) {
            		window.open('http://wpa.qq.com/msgrd?v=3&uin='+qq+'&site=qq&menu=yes','_brank');
            	} else {
            		window.open('tencent://message/?Menu=yes&uin='+qq
                			+'&Site=80fans&Service=300&sigT=45a1e5847943b64c6ff3990f8a9e644d2b31356cb0b4ac6b24663a3c8dd0f8aa12a545b1714f9d45',
                			'_blank');
            	}
            }
        }
    }
})
